#! /usr/bin/env python
# -*- coding: utf-8 -*-

from easygui import *
import os
import sys
import commands

usuario = ''
password_usuario = ''
password_root = ''
particion = ''
particion_home = ''
particion_home_formatear = False
swap = False
activar_root = False
activar_consolas = ''

def salir():
	msgbox("Instalación cancelada.", "Instalador")
	sys.exit(0)

def crear_particiones():
	msg = "Este programa instalará Debian en su disco duro.\n¿Desea continuar?"
	title = "Programa de instalación"
	if ccbox(msg, title, choices=('Continuar', 'Cancelar'), image="/usr/share/pixmaps/instalar.gif"):
		msg = "Debe tener al menos una partición de tipo linux (ext3, 83) de 14GB.\nSi aún no la ha creado, por favor hágalo ahora."
		title = "Particiones"
		choices = ['Particionar con GParted','Ya he definido mis particiones','Cancelar']
		reply = buttonbox(msg, title, image="/usr/share/pixmaps/instalar.gif", choices=choices)
		if reply:
			if reply == 'Particionar con GParted':
				commands.getoutput("sudo gparted")
			if reply == 'Ya he definido mis particiones':
				pass
			if reply == 'Cancelar':
				salir()
	else:
		salir()

def define_particion(msg):
	title = "Particiones"
	choices = []
	partitions = commands.getoutput("fdisk -l")
	partitions = partitions.split("\n")
	for partition in partitions:
		if "/dev/" in partition:
			parts = partition.split()
			if len(parts) >= 6:				
				if "/dev/" in parts[0]:
					# Partition
					device = parts[0]
					bootable = False
					x = 1
					if parts[1] == "*":
						bootable = True	
						x = x + 1
					start = parts[x]
					end = parts[x+1]
					blocks = parts[x+2]
					try: 
						if blocks[-1:] == "+":
							blocks = blocks[:-1]
						blocks = int(blocks) / 1024 / 1024
						blocks = str(blocks) + " GB"
					except Exception, detail:
						print detail
						pass
					code_type = (parts[x+3]).strip()
					str_type = ""			
					for subpart in parts[x+4:]:	
						str_type = str_type + subpart + " "						
					
					choice = device + ' ' + str(blocks) + ' ' + str_type + ' ' + code_type
					if choice.endswith('83'):
						choices.append(choice)

	choice = choicebox(msg, title, choices)
	if choice:
		return choice.split(' ')[0]
	else:
		salir()

def usar_particion_home():
	msg = "¿Desea utilizar una partición independiente para los datos de los usuarios (/home/)?"
	title = "Instalador"
	if ynbox(msg, title, choices=('Si', 'No'), image='/usr/share/pixmaps/instalar.gif'):
		return True
	return False

def usar_swap():
	msg = "Si no ha definido una partición swap y desea hacerlo ahora, de clic en \"Particionar con GParted\".\nSi ya tiene una partición swap creada, seleccione \"Ya tengo una swap\".\nSi desea usar un fichero de intercambio dentro de su partición del sistema, seleccione \"Usar un fichero de intercambio\""
	title = "Área de intercambio"
	choices = ['Particionar con GParted','Ya tengo una swap','Usar un fichero de intercambio','No utilizar swap']
	reply = buttonbox(msg, title, image="/usr/share/pixmaps/instalar.gif", choices=choices)
	if reply:
		if reply == 'Particionar con GParted':
			commands.getoutput("sudo gparted")
	return reply

def define_swap():
	opcion = usar_swap()
	if opcion == 'Ya tengo una swap' or opcion == 'Particionar con GParted':
		msg ="Seleccione la partición swap que desea utilizar."
		title = "Particiones"
		choices = []
		partitions = commands.getoutput("fdisk -l")
		partitions = partitions.split("\n")
		for partition in partitions:
			if "/dev/" in partition:
				parts = partition.split()
				if len(parts) >= 6:				
					if "/dev/" in parts[0]:
						# Partition
						device = parts[0]
						bootable = False
						x = 1
						if parts[1] == "*":
							bootable = True	
							x = x + 1
						start = parts[x]
						end = parts[x+1]
						blocks = parts[x+2]
						try: 
							if blocks[-1:] == "+":
								blocks = blocks[:-1]
								blocks = int(blocks) / 1024 / 1024
								blocks = str(blocks) + " GB"
						except Exception, detail:
							print detail
							pass
						code_type = (parts[x+3]).strip()
						str_type = ""			
						for subpart in parts[x+4:]:	
							str_type = str_type + subpart + " "						
					
						choice = device + ' ' + str(blocks) + ' ' + str_type + ' ' + code_type
						if choice.endswith('82'):
							choices.append(choice)

		choice = choicebox(msg, title, choices)
		if choice:
			return choice.split(' ')[0]

	return opcion

def define_usuario():
	msg = "Introduzca el nombre de usuario que desea utilizar en su nuevo sistema.\nEl nombre de usuario no puede ser root y solo debe contener letras."
	title = "Información de usuario:"
	fieldNames = ["Usuario"]
	return enterbox(msg, title, strip=True)

def define_password_usuario(usua):
	msg = "Introduzca la contraseña del usuario %s.\nLa contraseña debe contener al menos 5 caracteres." % usua
	title = "Contraseña de usuario %s" % usua
	return passwordbox(msg, title, default='')

def repetir_password_usuario(usua):
	password = define_password_usuario(usua)
	if password:
		msg = "Repetir la contraseña del usuario %s" % usua
		title = "Contraseña de usuario %s" % usua
		contra = passwordbox(msg, title, default='')
		if contra == password:
			return contra
		else:
			msgbox("Ambas contraseñas deben coincidir.", "Error")
	return None

def activar_cuenta_root():
	msg = "¿Desea activar la cuenta de root (superusuario administrador del sistema)?\nSi activa la cuenta de root, deberá introducir la contraseña de este usuario para ejecutar tareas administrativas.\nSi no la activa, nunca se le pedirá una contraseña para realizar estas tareas."
	title = "Instalador"
	if ynbox(msg, title, choices=('Activar', 'No activar'), image='/usr/share/pixmaps/instalar.gif'):
		return True
	return False

def activar_consolas_sistema():
	msg = "Puede activar varias consolas en su nuevo sistema.\nTenga en cuenta que cada consola consume memoria, mientras más consolas active, más memoria utilizará su sistema.\nEl entorno gráfico utiliza la consola #7.\nSi presiona Cancelar, se activarán 2 consolas."
	title = "Activar consolas"
	choices = ['Ninguna consola','Solo 1 consola para los mensajes del sistema','Solo 2 consolas: una para los mensajes del sistema y otra para mi usuario','Activar 6 consolas']
	choice = choicebox(msg, title, choices)
	return choice

def instalar():
	particion_home_msg = 'No utilizar una partición /home/ aparte.'
	particion_home_formatear_msg = ''
	if particion_home:
		particion_home_msg = particion_home
		particion_home_formatear_msg = '(No formatear)'
		if particion_home_formatear:
			particion_home_formatear_msg = '(Formatear)'
	activar_root_msg = 'No activarla'
	activar_consolas_msg = 'Solo 2 consolas: una para los mensajes del sistema y otra para mi usuario'
	if activar_root:
		activar_root_msg = 'Si, activarla'
	if activar_consolas:
		activar_consolas_msg = activar_consolas
	msg = "El sistema se instalará utilizando los siguientes datos suministrados por usted:\nUsuario: %s\nPartición /: %s\nUtilizar /home/ aparte: %s %s\nSWAP: %s\nActivar cuenta de root: %s\nActivar consolas: %s" % (usuario,particion,particion_home_msg,particion_home_formatear_msg,swap,activar_root_msg,activar_consolas_msg)
	title = "Instalador"
	if ynbox(msg, title, choices=('Instalar', 'Abortar'), image='/usr/share/pixmaps/instalar.gif'):
		os.system("umount /target/dev/")
		os.system("umount /target")
		os.system("rm -rf /target")
		os.system("mkdir /target")
		os.system("umount " + particion)
		os.system("mkfs.ext3 " + particion)
		os.system("tune2fs -r 5000 " + particion)
		if particion_home:
			os.system("umount " + particion_home)
			if particion_home_formatear:
				os.system("mkfs.ext3 " + particion_home)
				os.system("tune2fs -r 5000 " + particion_home)
		msgbox("Copiar ficheros del sistema.\nPor favor, sea paciente mientras se copia el sistema hacia su disco duro.\nEste proceso puede tardar unos 10 minutos, dependiendo de las características de su PC.", "Instalador")
		os.system("mount " + particion + " /target")
		os.system("rsync -av / /target/ --exclude-from=/usr/share/lib/instalador/exclude.list")
		msgbox("Configurando el sistema.", "Instalador")
		os.system("cp /target/usr/sbin/update-initramfs.distrib /target/usr/sbin/update-initramfs")
		os.system("cp /target/usr/sbin/update-initramfs.debian /target/usr/sbin/update-initramfs")
		os.system("mount -t tmpfs --bind /dev/ /target/dev/")
		os.system("mount -t sysfs --bind /sys/ /target/sys/")
		os.system("mount -t proc --bind /proc/ /target/proc/")
		os.system("echo \"proc		/proc	proc 	defaults 	0	0\" > /target/etc/fstab")
		os.system("echo \"" + particion + "	/	ext3	defaults,noatime	0	1\" >> /target/etc/fstab")
		if particion_home:
			os.system("echo \"" + particion_home + " /home	ext3	defaults	0	1\" >> /target/etc/fstab")
		if swap:
			if swap and swap != 'No utilizar swap':
				if swap == 'Usar un fichero de intercambio':
					os.system("dd if=/dev/zero of=/target/swapfile bs=1048 count=512000")
					os.system("mkswap /target/swapfile")
					os.system("echo \"/swapfile	swap	swap	defaults 	0	0\" >> /target/etc/fstab")
				else:
					os.system("echo \"" + swap + "	none   swap    sw    0    0\" >> /target/etc/fstab")
		os.system("grep -v user /etc/sudoers > /target/etc/sudoers")
		disco = particion
		if disco.__getitem__(disco.__len__() - 1).isalnum():
			disco = disco.replace(disco.__getitem__(disco.__len__() - 1),'')
		os.system("cp /target/root/.bashrc /target/root/.bashrc.orig")
		os.system("echo grub-install --recheck --no-floppy --root-directory=/ " + disco + " >> /target/root/.bashrc")
		os.system("echo update-grub >> /target/root/.bashrc")
		os.system("echo Sistema instalado completamente, ahora puede reiniciar su PC >> /target/root/.bashrc")
		os.system("echo mv /root/.bashrc.orig /root/.bashrc >> /target/root/.bashrc")
		os.system("echo exit >> /target/root/.bashrc")
		os.chroot("/target/")
		if particion_home:
			os.system("mount " + particion_home + " /home/")
		os.system("useradd -p `mkpasswd " + password_usuario + "` -m -s /bin/bash " + usuario)
		os.system("echo " + usuario + "   ALL=\\(ALL\\) NOPASSWD: ALL >> /etc/sudoers")
		grupos = ['cdrom','floppy','audio','dip','video','plugdev','users','powerdev','scanner','netdev','dialout','fuse','haldaemon']
		for grupo in grupos:
			os.system("adduser " + usuario + ' ' + grupo)
		os.system("userdel user")
		os.system("rm -fr /home/user")
		os.system("sed -i s,default_user\\ user,#default_user\\ user,g /etc/slim.conf")
		os.system("sed -i s,auto_login\\ yes,auto_login\\ no,g /etc/slim.conf")
		if activar_root:
			os.system("usermod -p `mkpasswd " + password_root + "` root")
		else:
			os.system("sed -i s,\"user\",\"" + usuario + "\",g /etc/PolicyKit/PolicyKit.conf")
			os.system("sed -i s,:user,:" + usuario + ",g /var/lib/polkit-1/localauthority/10-vendor.d/0-live-cd.pkla")
			os.system("echo 'SU_TO_ROOT_SU=sudo' >> /home/" + usuario + "/.su-to-rootrc")
			os.system("chown " + usuario + "." + usuario + "/home/" + usuario + "/.su-to-rootrc")
			os.system("sudo -u \"" + usuario + "\" gconftool-2 -s -t bool /apps/gksu/sudo-mode true")
			os.system("sudo -u \"" + usuario + "\" gconftool-2 -s -t bool /apps/gksu/display-no-pass-info false")
		os.system("sed -i s,-f\ user,-f\ " + usuario + ",g /etc/inittab")
		if activar_consolas:
			if activar_consolas == 'Ninguna consola':
				for consola in range(1,3):
					os.system("sed -i s," + str(consola) + ":23,#" + str(consola) + ":23,g /etc/inittab")
			if activar_consolas == 'Solo 1 consola para los mensajes del sistema':
				for consola in range(2,3):
					os.system("sed -i s," + str(consola) + ":23,#" + str(consola) + ":23,g /etc/inittab")
			if activar_consolas == 'Solo 2 consolas: una para los mensajes del sistema y otra para mi usuario':
				pass
			if activar_consolas == 'Activar 6 consolas':
				for consola in range(3,7):
					os.system("sed -i s,#" + str(consola) + ":23," + str(consola) + ":23,g /etc/inittab")
		msgbox("El sistema se ha copiado exitosamente.\nAhora se instalará GRUB, el gestor de arranque en su disco duro.", "Instalador")
	else:
		salir()

crear_particiones()

while not particion:
	msg = "Seleccione la partición donde desea instalar el sistema (debe tener al menos 4GB).\nTodos los datos que tenga en esa partición serán eliminados y no podrá recuperarlos."
	particion = define_particion(msg)

if usar_particion_home():
	msg = "Seleccione la partición que desea utilizar para los datos de usuarios (/home/)."
	particion_home = define_particion(msg)
	while particion_home == particion:
		msgbox("Usted seleccionó la misma partición que utilizará para la raíz de su sistema (/).", "Error")
		particion_home = define_particion(msg)
	if particion_home:
		msg = "¿Desea formatear la partición seleccionada para /home/?"
		title = "Instalador"
		if ynbox(msg, title, choices=('Si', 'No'), image='/usr/share/pixmaps/instalar.gif'):
			particion_home_formatear = True

swap = define_swap()

while not usuario or usuario == 'root' or not usuario.isalpha():
	usuario = define_usuario()
	if usuario:
		usuario = usuario.lower().replace(' ','')

while not password_usuario:
	password_usuario = repetir_password_usuario(usuario)
	if not password_usuario or password_usuario.__len__() < 5:
		msgbox("La contraseña debe tener al menos 5 caracteres.", "Error")

activar_root = activar_cuenta_root()
if activar_root:
	while not password_root:
		password_root = repetir_password_usuario('root (superusuario administrador del sistema)')
		if not password_root or password_root.__len__() < 5:
			msgbox("La contraseña debe tener al menos 5 caracteres.", "Error")

activar_consolas = activar_consolas_sistema()

if particion and usuario and password_usuario:
	instalar()

sys.exit(0)
